//
// Copyright (c) 1997 Vermeer Technologies, Inc., a wholly owned
//               subsidiary of Microsoft Corp.  All Rights Reserved
//
// File: VoteBotDialog.cpp
// Dialog Implementation File
//

#include "stdafx.h"
#include "votebot.h"
#include "VoteBotDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVoteBotDialog dialog


CVoteBotDialog::CVoteBotDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CVoteBotDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVoteBotDialog)
	m_votetype = 0;
	m_voteopt = 0;
	m_bModified = FALSE;
	m_bFirstEdit = FALSE;   // assume this is NOT the first time bot has been edited
	//}}AFX_DATA_INIT
}


void CVoteBotDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVoteBotDialog)
	DDX_Radio(pDX, IDC_OPINION, m_votetype);
	DDX_Radio(pDX, IDC_YESNO, m_voteopt);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CVoteBotDialog, CDialog)
	//{{AFX_MSG_MAP(CVoteBotDialog)
	ON_BN_CLICKED(IDC_AGREE, CVoteBotDialog::setModFlag)
	ON_BN_CLICKED(IDC_FORAGAINST, CVoteBotDialog::setModFlag)
	ON_BN_CLICKED(IDC_OPINION, CVoteBotDialog::setModFlag)
	ON_BN_CLICKED(IDC_PROPOSAL, CVoteBotDialog::setModFlag)
	ON_BN_CLICKED(IDC_YESNO, CVoteBotDialog::setModFlag)
	//}}AFX_MSG_MAP


END_MESSAGE_MAP()

void CVoteBotDialog::DialogToDictionary(CWebBotDict &dict)
{
	// read values from editor ui into corresopnding botdict values

	// map votetype (proposal/opinion)
		if (m_votetype==0)
		{	dict.SetValue("S-VOTETYPE", "OPINION");	}
		else if (m_votetype==1)
		{	dict.SetValue("S-VOTETYPE", "PROPOSAL");};

	// map voteopt (yes/no, agree/disagree, for/against)
		if (m_voteopt==0)
		{	dict.SetValue("S-VOTEOPT", "YES/NO");	}
		else if (m_voteopt==1)
		{	dict.SetValue("S-VOTEOPT", "AGREE");	}
		else if (m_voteopt==2)
		{	dict.SetValue("S-VOTEOPT", "FOR/AGAINST");};

}

void CVoteBotDialog::DictionaryToDialog(CWebBotDict &dict)
{   

	// read bot params from dictionary and map to component editor dialog

	// cast dict.GetValue so we can use it in a comparison
	CString sztemp = dict.GetValue("S-VOTETYPE");
 
	// get votetype attribute from botdict
	if (sztemp=="OPINION")
	{	m_votetype = 0; }
	else if (sztemp=="PROPOSAL") 
	{	m_votetype = 1;	}
	else 
	{	m_bFirstEdit = TRUE;	};   // First time bot has been inserted

	// get voteopt attribute from botdict
	sztemp = dict.GetValue("S-VOTEOPT");

	if (sztemp=="YES/NO")
	{	m_voteopt = 0;	}
	else if (sztemp=="AGREE")
	{	m_voteopt = 1;	}
	else if (sztemp=="FOR/AGAINST")
	{	m_voteopt = 2;	};


}


/////////////////////////////////////////////////////////////////////////////
// CVoteBotDialog message handlers

void CVoteBotDialog::setModFlag()
{
	// TODO: Add your control notification handler code here
	m_bModified = TRUE;

}
