VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Dict"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private colValues As Collection



Private Sub Class_Initialize()
    Set colValues = New Collection
End Sub


Public Sub Clear()
    Dim Attr As Attr
    For Each Attr In colValues
        Me.Remove Attr.Name
    Next
End Sub

Public Function Add(ByVal nmstr As String, ByVal valstr As String) As Attr
    ' don't allow duplicates
    Dim attrOld As Attr
    On Error GoTo NoDuplicate
    Set attrOld = colValues(nmstr)
    ' only get to here if it's a duplicate
    attrOld.Name = nmstr  ' keys are case-insensitive, so reset this as well
    attrOld.Value = valstr
    Exit Function
NoDuplicate:
    Dim attrNew As New Attr
    attrNew.Name = nmstr
    attrNew.Value = valstr
    colValues.Add attrNew, nmstr
    Set Add = attrNew
End Function



Public Sub Remove(ByVal Index As Variant)
    On Error GoTo ErrNoItem
    colValues.Remove Index
ErrNoItem:
    Exit Sub
End Sub

Public Function Item(ByVal Index As Variant) As Attr
    On Error GoTo ErrNoItem
    Set Item = colValues.Item(Index)
    Exit Function
ErrNoItem:
    Set Item = Nothing
    Exit Function
End Function

Public Sub LoadFromString(ByVal str As String)

    ' clear out any old Values first
    Me.Clear

    Dim cloc As Integer   ' location of found char
    Dim pos As Integer    ' current position in string
    Dim tail As Integer   ' last position in string
    Dim valsep As String  ' between Name and Value
    Dim pairsep As String ' between Name/Val pairs
    Dim pair As String    ' holds current Name/Val pair
    Dim nmstr As String   ' holds current Name
    Dim valstr As String  ' holds current Value
    
    valsep = "="
    pairsep = "&"
    
    pos = 1
    tail = Len(str)
    
    While pos <= tail
    
        ' find next pair
        cloc = InStr(pos, str, pairsep)
        If cloc > 0 Then
            pair = Mid$(str, pos, cloc - pos)
            pos = cloc + 1
        Else
            pair = Mid$(str, pos)
            pos = tail + 1
        End If
        
        ' split pair into Name and Value
        cloc = InStr(pair, valsep)
        If cloc > 0 Then
            nmstr = UrlDecodeString(Left$(pair, cloc - 1))
            valstr = UrlDecodeString(Mid$(pair, cloc + 1))
            Me.Add nmstr, valstr
        End If
    
    Wend

End Sub



Public Function DumpToString() As String
    Dim out As String
    Dim Attr As Attr
    Dim isfirst As Integer
    isfirst = True
    out = ""
    For Each Attr In colValues
        If isfirst Then
            isfirst = False
        Else
            out = out & "&"
        End If
        out = out & UrlEncodeString(Attr.Name) & "=" & UrlEncodeString(Attr.Value)
    Next
    DumpToString = out
End Function

Private Sub Class_Terminate()
    Me.Clear
    Set colValues = Nothing
End Sub





Public Property Get Count()
    On Error GoTo ErrEmpty
    Count = colValues.Count
    Exit Property
ErrEmpty:
    Count = 0
    Exit Property
End Property



Public Property Get Entries() As Collection
    Set Entries = colValues
End Property


Public Function HasEntry(nmstr As String) As Integer

    On Error GoTo NoSuchEntry
    Dim entry As Attr
    Set entry = colValues(nmstr)
    ' if get to here, key exists
    HasEntry = True
    Exit Function
    
NoSuchEntry:
    HasEntry = False

End Function
