Attribute VB_Name = "modUtil"
Option Explicit

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Private Const HWND_NOTOPMOST = -2
Private Const HWND_TOPMOST = -1
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOSIZE = &H1

Public Function UrlEncodeString(ByVal str As String) As String

    Dim pos As Long    ' current loc in src
    Dim last As Long   ' last loc in string
    Dim ch As String   ' current char
    Dim cc As Integer  ' char code
    Dim hstr As String ' hex string
    Dim out As String  ' output string
    
    Dim cSpace As Integer   ' code for space
    Dim cSquig As Integer   ' code for squiggle
    Dim cAmp As Integer     ' code for amp
    Dim cPlus As Integer    ' code for plus
    Dim cPct As Integer     ' code for percent
    Dim cEq As Integer      ' code for equals
    
    cSpace = Asc(" ")
    cSquig = Asc("~")
    cAmp = Asc("&")
    cPlus = Asc("+")
    cPct = Asc("%")
    cEq = Asc("=")
    
    last = Len(str)
    pos = 1
    
    While pos <= last
        ch = Mid$(str, pos, 1)
        cc = Asc(ch)
        If cc = cSpace Then
            out = out & "+"
        ElseIf (cc > cSpace And cc <= cSquig _
            And cc <> cAmp And cc <> cPlus _
            And cc <> cPct And cc <> cEq) Then
            out = out & ch
        Else
            ' convert to hex
            hstr = Hex$(cc)
            hstr = Right$(hstr, 2)  ' make sure it's only one byte
            If Len(hstr) = 0 Then
                hstr = "00"
            ElseIf Len(hstr) = 1 Then
                hstr = "0" & hstr
            End If
            out = out & "%" & hstr
        End If
        pos = pos + 1
    Wend
    
    UrlEncodeString = out

End Function



Public Function UrlDecodeString(ByVal inp As String) As String
        
    Dim out As String
    
    ' change all pluses (+) to spaces ( ),
    ' and change all hex strings (%xx) to actual chars

    Dim ch As String      ' current char
    Dim cc As Integer     ' current char code
    Dim pos As Integer    ' current position in string
    Dim tail As Integer   ' last position in string
    Dim hexstr As String  ' extracted hex Value
    
    Dim plusCode As Integer
    Dim pctCode As Integer
    
    plusCode = Asc("+")
    pctCode = Asc("%")
    
    pos = 1
    tail = Len(inp)
    
    While pos <= tail
    
        ch = Mid$(inp, pos, 1)
        cc = Asc(ch)
        
        If cc = plusCode Then
            out = out & " "
            pos = pos + 1
        ElseIf cc = pctCode Then
            hexstr = "&H" & Mid$(inp, pos + 1, 2)
            out = out & Chr$(Val(hexstr))
            pos = pos + 3
        Else
            ' regular char
            out = out & ch
            pos = pos + 1
        End If
                    
    Wend
    
    UrlDecodeString = out

End Function




Public Sub CenterForm(frm As Form, wnd As Long)

    Dim sx As Long
    Dim sy As Long
    
    If wnd <> 0 Then
        ' center over parent window
        Dim scrnRect As RECT
        Dim retval As Long
        retval = GetWindowRect(wnd, scrnRect)
        sx = scrnRect.Left + ((scrnRect.Right - scrnRect.Left) / 2)
        sx = sx * Screen.TwipsPerPixelX
        sx = sx - (frm.Width / 2)
        sy = scrnRect.Top + ((scrnRect.Bottom - scrnRect.Top) / 2)
        sy = sy * Screen.TwipsPerPixelY
        sy = sy - (frm.Height / 2)
    Else
        ' center on root
        sx = (Screen.Width / 2) - (frm.Width / 2)
        sy = (Screen.Height / 2) - (frm.Height / 2)
    End If
    
    ' make sure the entire form is on the screen
    If sx + frm.Width > Screen.Width Then sx = Screen.Width - frm.Width
    If sx < 0 Then sx = 0
    If sy + frm.Height > Screen.Height Then sy = Screen.Height - frm.Height
    If sy < 0 Then sy = 0
    
    ' move it
    frm.Move sx, sy

End Sub

Public Sub FloatForm(f As Form, yesno As Integer)

    Dim ret As Long

    If yesno Then
        ret = SetWindowPos(f.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
    Else
        ret = SetWindowPos(f.hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
    End If
    
End Sub
